/*
 * LuxoLET.java
 *
 * Created on 11. Dezember 2007, 20:35
 */

/*
 The contents of this file are subject to the
 Mozilla Public License Version 1.1 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at
 
 http://www.mozilla.org/MPL/
 
 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied.
 See the License for the specific language governing rights
 and limitations under the License.
 
 The Initial Developer of the Original Code is
 Georg-Johann Lay (GeorgJohann@web.de).
 
 Portions created by the Initial Developer are
 Copyright (C) 2007 Georg-Johann Lay. All Rights Reserved.
 
 Alternatively, the contents of this file may be used under the terms
 of either the GNU General Public License Version 3 or later (the "GPL"),
 or the GNU Lesser General Public License Version 3 or later (the "LGPL"),
 in which case the provisions of the GPL or the LGPL are applicable instead
 of those above.
 
 If you wish to allow use of your version of this file only
 under the terms of either the GPL or the LGPL, and not to allow others to
 use your version of this file under the terms of the MPL, indicate your
 decision by deleting the provisions above and replace them with the notice
 and other provisions required by the LGPL or the GPL. If you do not delete
 the provisions above, a recipient may use your version of this file under
 the terms of any one of the MPL, the GPL or the LGPL.
 */

package de.gjlay.mobile.luxo;

import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.*;

import de.gjlay.mobile.ui.HelpForm;
/**
 * The MIDlet implementing the Luxo, the "main" Object
 * @author Georg-Johann Lay
 */
public class LuxoLET 
        extends MIDlet
        implements CommandListener
{
    /// Luxo
    private LuxoCanvas luxo;
    
    /// Help
    private HelpForm helpForm;
    
    /// MIDlet's display
    private Display display;

    /// Back command (Help)
    private Command back;

    /// Exit command (Luxo)
    private Command exit;
    
    /// Help command (luxo)
    private Command help;

    /** 
     * Construct the MIDlet
     * Public constructor is needed.
     */
    public LuxoLET ()
    {
        initialize();
    }
    
    // Initialize our MIDlet
    private void initialize()
    {
        display = Display.getDisplay (this);
        luxo = new LuxoCanvas (display);
        helpForm = new HelpForm ();
        helpForm.setText ("Luxo's Help", LuxoCanvas.HelpText);
        
        // Set up the MIDLet to listen to Help abnd Luxo's command events
        luxo.setCommandListener (this);
        helpForm.setCommandListener (this);
        
        // Add the Exit command to Luxo
        luxo.addCommand (exit = new Command ("Exit", Command.EXIT, 2));
        
        // Add the Help command to Luxo
        luxo.addCommand (help = new Command ("Help", Command.HELP, 1));
        
        // Add the Back command to the Luxo's help
        helpForm.addCommand (back = new Command ("Back", Command.BACK, 1));
    }
    
    /** Start the MIDlet */
    public void startApp ()
    {
        display.setCurrent (luxo);
    }
    
    /** Pause the MIDlet */
    public void pauseApp ()
    {
    }
    
    /** Destroy the MIDlet */
    public void destroyApp (boolean unconditional)
    {
    }
    
    /**
     * Called when action should be handled
     */
    public void commandAction (Command command, Displayable displayable)
    {
        if (luxo == displayable)
        {
            if (exit == command)
            {
                display.setCurrent (null);
                destroyApp (true);
                notifyDestroyed ();
            }
            if (help == command)
            {
                display.setCurrent (helpForm);
            }
        }
        
        if (helpForm == displayable)
        {
            // All we have is "Back"...
            display.setCurrent (luxo);
        }
    }
}
